!-------------------------------------------------
!   area.f90
!   Marking region of interest for DEM
!    K. Suzuki, Niigata University
!--------------------------------------------------

!                   BL16XUようにカスタマイズ
program area
  implicit none
  
  character:: filename*50,file2*50
  integer:: i,j,m,n,w,h
  real*4:: x(0:2000,0:2000)
  integer:: roi(0:2000,0:2000)=0
  real*4:: phi, r, tth=9.0, pi=3.14159,dphi,dth,th=9.05
  real*4:: l=500.0, l0=420.13,x1,z1,a=0.172
  real*4:: x01=234.261,y01=92.874,x02=231.485,y02=89.742
  integer:: ox,oy,n1,n2



  n1=20; n2=100 !分割数
  w=486;h=194  ! 画像サイズ                   w=0:486 h=0:195
  
  print *,"filename"
  read(5,*) filename

  
  open(unit=11,file=filename,status='old')
    do j=0,h
      read(11,*) (x(i,j),i=0,w)
    end do
  close(11)
  
  print *,'P1h = 1, P1h = 2, P1r = 3, P2r = 4'
  print *,'読み込んだ画像のタイプの番号を入れてください．'
  read(5,*) m
  
  dth = 0.30/float(n1)
  dphi = 10.0/float(n2)

  if (m == 1) then  !　P1hの場合
    do j=-n1,n1
      do i=-n2,n2
        r= l0*cos(tth*pi/180.)*tan(pi/180.0*(th+dth*real(j)))
        phi= pi/180.0*dphi*real(i)
        x1 = r*sin(phi); z1 = r*cos(phi)   !experimental space
        !実験室座標から検出器座標ox,oyへ
        ox=nint(x01-x1/a)
        oy=nint(y01 +cos(tth*pi/180.0)/a*(l0*sin(tth*pi/180)-z1))
        if (roi(ox,oy) == 0) then
          roi(ox,oy) = 1
        end if
      end do
    end do
  end if
  
  if (m == 2) then  !　P2hの場合
    do j=-n1,n1
      do i=-n2,n2
        r= (l0+l)*cos(tth*pi/180.)*tan(pi/180.0*(th+dth*real(j)))
        phi= pi/180.0*dphi*real(i)
        x1 = r*sin(phi); z1 = r*cos(phi)   !experimental space
        !実験室座標から検出器座標ox,oyへ
        ox=nint(x02-x1/a)
        oy=nint(y02 +cos(tth*pi/180.0)/a*((l0+l)*sin(tth*pi/180)-z1))
        if (roi(ox,oy) == 0) then
          roi(ox,oy) = 1
        end if
      end do
    end do
  end if
  

  if (m == 3) then  !　P1rの場合
    do j=-n1,n1
      do i=-n2,n2
        r= l0*cos(tth*pi/180.)*tan(pi/180.0*(th+dth*real(j)))
        phi= pi/180.0*dphi*real(i)
        z1 = -r*sin(phi); x1 = r*cos(phi)   !experimental space
        !実験室座標から検出器座標ox,oyへ
        ox=nint(x01-z1/a)
        oy=nint(y01 +cos(tth*pi/180.0)/a*(l0*sin(tth*pi/180)-x1))
        if (roi(ox,oy) == 0) then
          roi(ox,oy) = 1
        end if
      end do
    end do
  end if

  
  if (m == 4) then  !　P2rの場合
    do j=-n1,n1
      do i=-n2,n2
        r= (l0+l)*cos(tth*pi/180.)*tan(pi/180.0*(th+dth*real(j)))
        phi= pi/180.0*dphi*real(i)
        z1 = r*sin(phi); x1 = r*cos(phi)   !experimental space
        !実験室座標から検出器座標ox,oyへ
        ox=nint(x02-z1/a)
        oy=nint(y02 +cos(tth*pi/180.0)/a*((l0+l)*sin(tth*pi/180)-x1))
        if (roi(ox,oy) == 0) then
          roi(ox,oy) = 1
        end if
      end do
    end do
  end if
  ! --------------- Paint ROI -------------
  do j=0,h
    do i=0,w
      if(roi(i,j) == 1) then
        x(i,j)=x(i,j) + 60.0
      end if
    end do
  end do
  
  file2="ROI_"//trim(adjustl(filename))
    open(unit=12,file=file2,status='unknown')
    do j=0,h
      write(12,*) (x(i,j),i=0,w)
    end do
  close(12)
  
  end program area