//                関心領域(roi: Region of Interest)をcopyしてテキストファイルを作成するマクロ
//                            併せて欠陥画素(233,299) の処理もします．CdTe PILATUS-300K
//                               CdTe PILATUS-300K用, copy_paste.ijm,   by K. Suzuki Niigata University

// 2023/12/5 PILATUS故障により　下段のセグメントから回折像を取り出すように変更
// ROIのスタックを作成するマクロも追加しました．

macro "PILATUS画像からの切り出し" {
  //imgのあるディレクトリdirを指定
    print("【注意】CdTe PILATAUSに合わせて作成したので，");
    print("処理する一連のファイル名は，????_00001.tif の形式を前提にしています．");
    print("もし異なる場合は，ファイル名形式を変更するか，マクロを修正してください．");
  print("処理するフォルダーを指定してください．");
  dir1 = getDirectory("Choose a Directory");
  print(dir1);
  //切り取りした画像の保存フォルダーを作る
  dir2=dir1 + "target";
  File.makeDirectory(dir2);
  print("切り出した画像を保存するフォルダー(target)を作成しました．");
  print(dir2);
  
  print("処理する最初のファイルを指定(拡張子も含む)してください．");
  fname=getString("処理最初のファイルを入力", "file_name"); //ファイル名の取得
  
  // ファイル名から 00000.tif の9文字を除いた部分を取り出す．
  length=lengthOf(fname);  //フアイル名の文字数
  
  file_name = substring(fname,0,length-9);	//フアイル名の部分
  suji = substring(fname,length-9,length-4); // 連番部分
  extension = substring(fname,length-4,length);	//拡張子
   print(file_name);
   print(suji);
   print(extension);
  
  st1 = 0;   //処理開始番号
  st1 = parseInt(suji);
  st2 = 100; //処理終了番号
  st2 = getNumber("処理終了する番号を入力",st2);
  // print(st1,st2);
  
  //一括処理の開始 copy+paste
  for (i=st1; i < st2+1; i++) {
    x=""+i;
    number="00000"+x;
    mojisu=lengthOf(number);
    remban=substring(number,mojisu-5,mojisu);
    print(remban);
    newfile =dir1 + "/" + file_name + remban + extension;
            
            open(newfile);
    //run("Brightness/Contrast...");
    setMinAndMax(-20, 500);
    run("Fire");
    
    // 欠陥画素(233,299) の処理
    
//    c1=getPixel(233,298);  //画像上の(x,y)のピクセル値を変数に返す。
//    c2=getPixel(232,299);
//    c3=getPixel(234,299);
//    c4=getPixel(233,300);
//    ca=(c1+c2+c3+c4)/4;
//    setPixel(233,299,ca);  //(x,y)のピクセル値を数値で置き換える。
    
    //setTool("rectangle");
    makeRectangle(0, 424, 487, 195); // (0,424)の点から幅487x高さ195のROI (下段)
    run("Copy");  // ROIのcopy
    close();
    run("Internal Clipboard"); 
    setMinAndMax(-20, 500);
    run("Fire");
    
    fname_out="roi_" + x;
    file_out = dir2 + "/" + fname_out + ".txt";
    print(file_out);
    saveAs("Text Image", file_out);
    file_tiff= dir2 + "/z_" + x ;
            saveAs("Tiff", file_tiff);
    // wait(800);
    close();
  }
  
}
///
// targetP1のx1_i.txtのスタック
macro "P1積分領域のスタック" {
  print("処理するフォルダーtargetP1を指定してください．");
  dir1 = getDirectory("Choose a Directory");
  print(dir1);
 

   st1 = 0;   //処理開始番号
   st1 = getNumber("処理終了する番号を入力",st1);
   st2 = 100; //処理終了番号
   st2 = getNumber("処理終了する番号を入力",st2);
  // print(st1,st2);

      //一括処理の開始
  for (i=st1; i < st2+1; i++) {
	xfile= "open=" + dir1 + "x1_" + i + ".txt";
	print(xfile);

	run("Text Image... ", xfile);
	run("Fire");
	//run("Brightness/Contrast...");
	setMinAndMax(-20, 1000);
  }
  run("Images to Stack", "name=Stack_x1 use");
}

// ~~~~~~~~~~~~~~~~~ targetP2のx2_i.txtのスタック
macro "P2積分領域のスタック" {
  print("処理するフォルダーtargetP2を指定してください．");
  dir1 = getDirectory("Choose a Directory");
  print(dir1);
 

   st1 = 0;   //処理開始番号
   st1 = getNumber("処理終了する番号を入力",st1);
   st2 = 100; //処理終了番号
   st2 = getNumber("処理終了する番号を入力",st2);
  // print(st1,st2);

      //一括処理の開始
  for (i=st1; i < st2+1; i++) {
	xfile= "open=" + dir1 + "x2_" + i + ".txt";
	print(xfile);

	run("Text Image... ", xfile);
	run("Fire");
	//run("Brightness/Contrast...");
	setMinAndMax(-20, 1000);
  }
  run("Images to Stack", "name=Stack_x2 use");
}

